--Run SLH_Config_Lua  	
	SLH_AL_Lua = CreateFrame("Frame", "SLH_AL_Lua")
	SLH_AL_Lua:RegisterEvent("ADDON_LOADED")
	SLH_AL_Lua:HookScript("OnEvent", function (self, event, name, ...)
		if (name ~= "SalensLittleHelper") then return end

		--Theoretically speeds up access to global variables by making them local.  This is supposed to be faster.  I have no proof this is true.	
			local _G_SLH = _G 
		
		local SLH_PCSV_UnitName = _G_SLH["SLH_PCSV"]["SLH_PCSV_UnitNameGlobal"]
		local AL_Profile = _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AL_Profile"]

		--Development Mode Boolean (Controls various Overrides, disable to test and distribute.)
			local SLH_AL_DevMode = false
			--[[DevMode]]if SLH_AL_DevMode and name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("AL_Lua addonName: " .. name) end	

		-- Set Variables
			local SLH_AL_SetVars = function (self, event, name, ...)
				-- Test/Create SLH_SV Table			
					if _G_SLH["SLH_SV"] == nil then _G_SLH["SLH_SV"] = {} end			
				-- Test/Create SLH_SV.AL_Profile Table
					if _G_SLH["SLH_SV"][AL_Profile] == nil then _G_SLH["SLH_SV"][AL_Profile] = {}  end	
				-- Test/Create SLH_AL Table
					if _G_SLH["SLH_SV"][AL_Profile]["AL"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"] = {}  end	
						
				-- Test/Create SLH_AL Variables
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["Enable"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["Enable"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootPoor"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootPoor"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootCommon"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootCommon"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootUnCommon"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootUnCommon"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootRare"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootRare"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootEpic"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootEpic"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootLegendary"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootLegendary"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootArtifact"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootArtifact"] = "Y" end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["FreeBagSlotLimit"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["FreeBagSlotLimit"] = 0 end
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["BagSlotLimitMessage"] == nil then _G_SLH["SLH_SV"][AL_Profile]["AL"]["BagSlotLimitMessage"] = "Y" end
			end

		--SLH_AL Module
			local SLH_AL_Module = function (SLH_ALOptions, event, name, ...)
				if IsAltKeyDown() then return end	
				SLH_AL_numLootItems = GetNumLootItems()
					
				for i = 1, SLH_AL_numLootItems do
					SLH_AL_numberOfFreeSlots = GetContainerNumFreeSlots(0) + GetContainerNumFreeSlots(1) + GetContainerNumFreeSlots(2) + GetContainerNumFreeSlots(3) + GetContainerNumFreeSlots(4)
					if 	SLH_AL_numberOfFreeSlots <= _G_SLH["SLH_SV"][AL_Profile]["AL"]["FreeBagSlotLimit"]
					then	
						if _G_SLH["SLH_SV"][AL_Profile]["AL"]["BagSlotLimitMessage"] == "Y"
						then
							if _G_SLH["SLH_SV"][AL_Profile]["AL"]["FreeBagSlotLimit"] ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("Not enough Bags slots to loot.  Bag slot loot threshold is " .. _G_SLH["SLH_SV"][AL_Profile]["AL"]["FreeBagSlotLimit"]) end 
						end
					else
						
						local SLH_AL_lootIcon, 
						SLH_AL_lootName, 
						SLH_AL_lootQuantity,  -- Number - The quantity of the item in a stack. Note: Quantity for coin is always 0.
						SLH_AL_currencyID, 
						SLH_AL_lootQuality,  -- 0 - Poor,1 - Common,2 - Uncommon,3 - Rare,4 - Epic,5 - Legendary,6 - Artifact
						SLH_AL_locked, 
						SLH_AL_isQuestItem, 
						SLH_AL_questID, 
						SLH_AL_isActive
						= GetLootSlotInfo(i)		
						 
						local SLH_AL_lootmethod, --String (LootMethod) - One of 'freeforall', 'roundrobin', 'master', 'group', 'needbeforegreed', 'personalloot'. Appears to be 'freeforall' if you are not grouped.
						SLH_AL_masterlooterPartyID, --Number - Returns 0 if player is the mater looter, 1-4 if party member is master looter (corresponding to party1-4) and nil if the master looter isn't in the player's party or master looting is not used.
						SLH_AL_masterlooterRaidID = GetLootMethod() --Number - Returns index of the master looter in the raid (corresponding to a raidX unit), or nil if the player is not in a raid or master looting is not used.

						SLH_AL_MasterLootThreshold = GetLootThreshold()
						if SLH_MasterLootThreshold == nil then SLH_MasterLootThreshold = 0 end	
						
						
						if SLH_AL_lootQuantity == 0 
						then 
							securecall(LootSlot,i)
						elseif not(SLH_AL_lootmethod == "master") or (SLH_AL_lootmethod == "master" and (IsMasterLooter or (SLH_AL_lootQuality <= SLH_MasterLootThreshold)))
						then
							if (LootSlotHasItem(i))and (
								(SLH_AL_lootQuality == 0 and _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootPoor"] == "Y") or
								(SLH_AL_lootQuality == 1 and _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootCommon"] == "Y") or
								(SLH_AL_lootQuality == 2 and _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootUnCommon"] == "Y") or
								(SLH_AL_lootQuality == 3 and _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootRare"] == "Y") or
								(SLH_AL_lootQuality == 4 and _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootEpic"] == "Y") or
								(SLH_AL_lootQuality == 5 and _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootLegendary"] == "Y") or
								(SLH_AL_lootQuality == 6 and _G_SLH["SLH_SV"][AL_Profile]["AL"]["LootArtifact"] == "Y"))
							then
								securecall(LootSlot,i)								
							end	
						
						end
					end
				end
			end

		--SLH_AL EventCall
			local SLH_AL_Events = function (SLH_ALOptions, event, name, ...)
				--Create SLH_AL EventFrame
					SLH_ALEventFrame = CreateFrame("Frame","SLH_ALEventFrame")

				-- Register SLH_AL events
					--Movement
						SLH_ALEventFrame:RegisterEvent("LOOT_READY")
						SLH_ALEventFrame:RegisterEvent("LOOT_OPENED")

				--Call SLH_AL HookScript
					if _G_SLH["SLH_SV"][AL_Profile]["AL"]["Enable"] == "Y"
						then SLH_ALEventFrame:HookScript("OnEvent", SLH_AL_Module)
					end
			end

		--SLH_AL Config Screen
			local SLH_AL_Frames = function  (self, event, name, ...)

				-- SLH_AL Options
						SLH_ALOptions = CreateFrame( "Frame", "SLH_ALOptions")
						SLH_ALOptions.name = "Auto Loot Control"
						-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
							SLH_ALOptions.parent = SLH_Config_Panel.name
						-- Add the child to the Interface Options
							InterfaceOptions_AddCategory(SLH_ALOptions)
						--Add Title
							local SLH_ALOptionsTitle = SLH_ALOptions:CreateFontString(nil, "ARTWORK","GameFontNormalLarge")
							SLH_ALOptionsTitle:SetPoint("TOPLEFT", 10, -10)
							SLH_ALOptionsTitle:SetText("Salen's Little Helper - Loot Control Options")			
					
				--SLH_ALDetail - Create Scroll Frame		
					SLH_ALDetail = securecall(_G_SLH["SLH_SF"]["SLH_CreateScrollFrame"],SLH_ALOptions, --self
						"SLH_ALDetail", --FrameName
						SLH_ALOptions, --TOPLEFTrelativeFrame
						5, --TOPLEFTxOffset
						-30, --TOPLEFTyOffset
						SLH_ALOptions, --BOTTOMRIGHTrelativeFrame
						-5, --BOTTOMRIGHTxOffset
						5,--BOTTOMRIGHTyOffset
						"Loot Control Options" -- Title
						)
					SLH_ALDetail.parent = SLH_ALOptions
					
					SLH_ALDetail.ScrollBar:ClearAllPoints()
					SLH_ALDetail.ScrollBar:SetPoint("TOPLEFT", SLH_ALDetail, "TOPRIGHT", -25, -20)
					SLH_ALDetail.ScrollBar:SetPoint("BOTTOMRIGHT", SLH_ALDetail, "BOTTOMRIGHT", -5, 25)
					SLH_ALDetail:SetClipsChildren(true)		
					
					--(Uncomment to) Set Background Color
						--SLH_ALDetail.bg = SLH_ALDetail:CreateTexture(nil, "BACKGROUND")
						--SLH_ALDetail.bg:SetAllPoints(true)
						--SLH_ALDetail.bg:SetColorTexture(0.8, 0.4, 0, 0.2)
					--End Set Background Color

					--SLH_ALDetailScrollFrameChild
						local SLH_ALDetailScrollFrameChild = CreateFrame("Frame", nil, SLH_ALDetail)
						SLH_ALDetailScrollFrameChild:SetSize(600, 470)
							--(Uncomment to) Set Background Color
								--SLH_ALDetailScrollFrameChild.bg = SLH_ALDetailScrollFrameChild:CreateTexture(nil, "BACKGROUND")
								--SLH_ALDetailScrollFrameChild.bg:SetAllPoints(true)
								--SLH_ALDetailScrollFrameChild.bg:SetColorTexture(0.2, 0.6, 0, 0.8)
							--End Set Background Color
						SLH_ALDetail:SetScrollChild(SLH_ALDetailScrollFrameChild)	
						SLH_ALDetailScrollFrameChild:SetClipsChildren(true)		
			
					

					--SLH_ALDetail Title 
						SLH_ALDetailScrollFrameChild.title = SLH_ALDetailScrollFrameChild:CreateFontString (nil, "OVERLAY")
						SLH_ALDetailScrollFrameChild.title:SetFontObject("GameFontHighlight")
						SLH_ALDetailScrollFrameChild.title:SetPoint("LEFT", SLH_ALDetailScrollFrameChild.TitleBg, "LEFT", 5, 0)
						SLH_ALDetailScrollFrameChild.title:SetText("Loot Control Options")	
						SLH_ALDetailScrollFrameChild.title:SetTextColor(_G_SLH["SLH_SF"]["SLH_TitleColors"].r, _G_SLH["SLH_SF"]["SLH_TitleColors"].g, _G_SLH["SLH_SF"]["SLH_TitleColors"].b, _G_SLH["SLH_SF"]["SLH_TitleColors"].a)					

					--MasterFrame.SLH_ALDetail Buttons
						-- Enable_SLH_AL Check Button:
							SLH_ALDetailScrollFrameChild.Enable_SLH_AL = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_ALDetailScrollFrameChild, --relativeFrame
								"Enable_SLH_AL", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"Enable", --SVPath3
								"Enable Loot Control", --text
								"Enables Fast Auto Looting\n\nWorks whether Blizzard AutoLoot Option is enabled or not\n\n'Should' Work with Master Looter.  This has been scripted but not tested, let me know if it works or not...\n\nHolding Alt key disables Loot Control on the fly" --tooltip
								)
								Enable_SLH_AL:HookScript("OnClick", function(self, arg1)			
									if Enable_SLH_AL:GetChecked() 
									then 
										_G_SLH["SLH_SV"][AL_Profile]["AL"]["Enable"] = "Y"
										SLH_AL_SetVars(self, event, name)
										SLH_AL_Events(self, event, name)
									else 
										_G_SLH["SLH_SV"][AL_Profile]["AL"]["Enable"] = "N"
										SLH_ALEventFrame:UnregisterAllEvents()																		
									end
								end)
				
			
						-- SLH_AL_FreeBagSlotLimit 
							SLH_AL_FreeBagSlotLimit = securecall(_G_SLH["SLH_SF"]["SLH_CreateSlider"],SLH_ALOptions, --
								"TOPLEFT", --point
								Enable_SLH_AL, --relativeFrame
								"SLH_AL_FreeBagSlotLimit" , --FrameName
								"TOPLEFT", --relativePoint
								10, --xOffset
								-50, --yOffset
								0, --Min
								50, --Max
								_G_SLH["SLH_SV"][AL_Profile]["AL"]["FreeBagSlotLimit"], --Value
								1, --Step
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"FreeBagSlotLimit", --SVPath3
								"Free Bag Slot Limit", --text
								"Do not loot if you have this many bag slots or less free\n\nDefault = 0\n\nLImit Does not work if Blizzard Auto Loot is On, as Blizzard AutoLoot will still occur." --tooltip
								)

								
						-- SHow/Hide :
							SLH_AL_BagSlotLimitMessage = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_FreeBagSlotLimit, --relativeFrame
								"SLH_AL_BagSlotLimitMessage" , --FrameName
								"BOTTOMLEFT", --relativePoint
								20, --Width
								20, --Height
								-10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"BagSlotLimitMessage", --SVPath3
								"Show Bag Slot Limit Message", --text
								"Show Bag Slot Limit Message, when attempting to Loot without enough Slots\n\nYes or No\n\nLoot Window remains open when message is disabled and Slots are below Limit" --tooltip
								)

								
						-- Enable_SLH_AL Check Button:
							SLH_AL_LootPoor = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_BagSlotLimitMessage, --relativeFrame
								"SLH_AL_LootPoor" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"LootPoor", --SVPath3
								"Loot 'Poor' Items?", --text
								"Loot 'Poor' Items?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AL Check Button:
							SLH_AL_LootCommon = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_LootPoor, --relativeFrame
								"SLH_AL_LootCommon" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"LootCommon", --SVPath3
								"Loot 'Common' Items?", --text
								"Loot 'Common' Items?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AL Check Button:
							SLH_AL_LootUncommon = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_LootCommon, --relativeFrame
								"SLH_AL_LootUncommon" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"LootUnCommon", --SVPath3
								"Loot 'UnCommon' Items?", --text
								"Loot 'UnCommon' Items?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AL Check Button:
							SLH_AL_LootRare = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_LootUncommon, --relativeFrame
								"SLH_AL_LootRare" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"LootRare", --SVPath3
								"Loot 'Rare' Items?", --text
								"Loot 'Rare' Items?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AL Check Button:
							SLH_AL_LootEpic = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_LootRare, --relativeFrame
								"SLH_AL_LootEpic" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"LootEpic", --SVPath3
								"Loot 'Epic' Items?", --text
								"Loot 'Epic' Items?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AL Check Button:
							SLH_AL_LootLegendary = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_LootEpic, --relativeFrame
								"SLH_AL_LootLegendary" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"LootLegendary", --SVPath3
								"Loot 'Legendary' Items?", --text
								"Loot 'Legendary' Items?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AL Check Button:
							SLH_AL_LootArtifact = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_ALOptions, --self
								"TOPLEFT", --point
								SLH_AL_LootLegendary, --relativeFrame
								"SLH_AL_LootArtifact" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AL_Profile, --SVPath1
								"AL", --SVPath2
								"LootArtifact", --SVPath3
								"Loot 'Artifact' Items?", --text
								"Loot 'Artifact' Items?\n\nYes or No" --tooltip
								)	
			end

				
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AL_Load"] == "Y" then
				SLH_AL_SetVars(self, event, name, ...)
				SLH_AL_Events(self, event, name, ...)
			end
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AL_Hide"] == "N" then
				SLH_AL_Frames(self, event, name, ...)
			end
		
	end	)	