--Run SLH_Config_Lua  	
	SLH_AR_Lua = CreateFrame("Frame", "SLH_AR_Lua")
	SLH_AR_Lua:RegisterEvent("ADDON_LOADED")
	SLH_AR_Lua:HookScript("OnEvent", function (self, event, name, ...)
		if (name ~= "SalensLittleHelper") then return end

		--Theoretically speeds up access to global variables by making them local.  This is supposed to be faster.  I have no proof this is true.	
			local _G_SLH = _G 

		local SLH_PCSV_UnitName = _G_SLH["SLH_PCSV"]["SLH_PCSV_UnitNameGlobal"]
		local AR_Profile = _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AR_Profile"]
			
		--Development Mode Boolean (Controls various Overrides, disable to test and distribute.)
			local SLH_AR_DevMode = false
			--[[DevMode]]if SLH_AR_DevMode and name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("AR_Lua addonName: " .. name) end	
					
		-- Set Variables
			local SLH_AR_SetVars = function (self, event, name, ...)
				-- Test/Create SLH_SV Table		
					if _G_SLH["SLH_SV"] == nil then _G_SLH["SLH_SV"] = {} end			
				-- Test/Create SLH_SV.AR_Profile Table
					if _G_SLH["SLH_SV"][AR_Profile] == nil then _G_SLH["SLH_SV"][AR_Profile] = {}  end	
				-- Test/Create SLH_AR Table
					if _G_SLH["SLH_SV"][AR_Profile]["AR"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"] = {}  end	
						
				-- Test/Create SLH_AR Variables
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] = "Y" end
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["PlayerFund"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"]["PlayerFund"] = "Y" end
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["GuildFund"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"]["GuildFund"] = "N" end
			end

		--SLH_AR Module
			local SLH_AR_Module = function (SLH_AROptions, event, name, ...)
				if IsAltKeyDown() then return end
				if CanMerchantRepair() 
				then
					local SLH_repairAllCost, 
						SLH_canRepair = GetRepairAllCost()

					if SLH_canRepair
					then
						Gold_SLH_repairAllCost = math.floor (SLH_repairAllCost/10000)
						Silver_SLH_repairAllCost = math.floor ((SLH_repairAllCost-(Gold_SLH_repairAllCost*10000))/100)
						Copper_SLH_repairAllCost = (SLH_repairAllCost-(Gold_SLH_repairAllCost*10000)-(Silver_SLH_repairAllCost*100))
						
						GSC_SLH_repairAllCost = Gold_SLH_repairAllCost .. " Gold, " .. Silver_SLH_repairAllCost .. " Silver, " .. Copper_SLH_repairAllCost .. " Copper"
						
						GSC_Icons_SLH_repairAllCost = GetCoinTextureString(SLH_repairAllCost)
						
						--RepairAllItems([guildBankRepair]) --guildBankRepair - Flag (Optional) - If 1, use guild funds to repair. If 0, nil, or missing, use player fund
						if CanGuildBankRepair() and _G_SLH["SLH_SV"][AR_Profile]["AR"]["GuildFund"] == "Y"
						then securecall(RepairAllItems,1)
							if GSC_Icons_SLH_repairAllCost ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("Repaired Using Guild Bank Funds: " .. GSC_Icons_SLH_repairAllCost) end		
						elseif _G_SLH["SLH_SV"][AR_Profile]["AR"]["PlayerFund"] == "Y"
						then securecall(RepairAllItems)
							if GSC_Icons_SLH_repairAllCost ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("Repaired Using Player Funds: " .. GSC_Icons_SLH_repairAllCost) end
						end
					end
				end		
			end

		--SLH_AR EventCall
			local SLH_AR_Events = function (SLH_AROptions, event, name, ...)
				--Create SLH_AR EventFrame
					SLH_AREventFrame = CreateFrame("Frame","SLH_AREventFrame")

				-- Register SLH_AR events
					--Movement
						SLH_AREventFrame:RegisterEvent("MERCHANT_SHOW")

				--Call SLH_AR HookScript
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] == "Y"
						then SLH_AREventFrame:HookScript("OnEvent", SLH_AR_Module)
					end
			end

		--SLH_AR Config Screen
			local SLH_AR_Frames= function  (self, event, name, ...)

				-- SLH_AR Options
							SLH_AROptions = CreateFrame( "Frame", "SLH_AROptions")
						SLH_AROptions.name = "Auto Repair"
						-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
							SLH_AROptions.parent = SLH_Config_Panel.name
						-- Add the child to the Interface Options
							InterfaceOptions_AddCategory(SLH_AROptions)
						--Add Title
							local SLH_AROptionsTitle = SLH_AROptions:CreateFontString(nil, "ARTWORK","GameFontNormalLarge")
							SLH_AROptionsTitle:SetPoint("TOPLEFT", 10, -10)
							SLH_AROptionsTitle:SetText("Salen's Little Helper - Auto Repair Options")			
					
				--SLH_ARDetail - Create Scroll Frame		
					SLH_ARDetail = securecall(_G_SLH["SLH_SF"]["SLH_CreateScrollFrame"],SLH_AROptions, --self
						"SLH_ARDetail", --FrameName
						SLH_AROptions, --relativeFrame
						5, --Offset
						-30, --yOffset
						SLH_AROptions, --relativeFrame
						-5, --xOffset
						5,--yOffset
						"Auto Repair Options" -- Title
						)
					SLH_ARDetail.parent = SLH_AROptions
					
					SLH_ARDetail.ScrollBar:ClearAllPoints()
					SLH_ARDetail.ScrollBar:SetPoint("TOPLEFT", SLH_ARDetail, "TOPRIGHT", -25, -20)
					SLH_ARDetail.ScrollBar:SetPoint("BOTTOMRIGHT", SLH_ARDetail, "BOTTOMRIGHT", -5, 25)
					SLH_ARDetail:SetClipsChildren(true)		
					
					--(Uncomment to) Set Background Color
						--SLH_ARDetail.bg = SLH_ARDetail:CreateTexture(nil, "BACKGROUND")
						--SLH_ARDetail.bg:SetAllPoints(true)
						--SLH_ARDetail.bg:SetColorTexture(0.8, 0.4, 0, 0.2)
					--End Set Background Color

					--SLH_ARDetailScrollFrameChild
						local SLH_ARDetailScrollFrameChild = CreateFrame("Frame", nil, SLH_ARDetail)
						SLH_ARDetailScrollFrameChild:SetSize(600, 470)
							--(Uncomment to) Set Background Color
								--SLH_ARDetailScrollFrameChild.bg = SLH_ARDetailScrollFrameChild:CreateTexture(nil, "BACKGROUND")
								--SLH_ARDetailScrollFrameChild.bg:SetAllPoints(true)
								--SLH_ARDetailScrollFrameChild.bg:SetColorTexture(0.2, 0.6, 0, 0.8)
							--End Set Background Color
						SLH_ARDetail:SetScrollChild(SLH_ARDetailScrollFrameChild)	
						SLH_ARDetailScrollFrameChild:SetClipsChildren(true)		
			
					

					--SLH_ARDetail Title 
						SLH_ARDetailScrollFrameChild.title = SLH_ARDetailScrollFrameChild:CreateFontString (nil, "OVERLAY")
						SLH_ARDetailScrollFrameChild.title:SetFontObject("GameFontHighlight")
						SLH_ARDetailScrollFrameChild.title:SetPoint("LEFT", SLH_ARDetailScrollFrameChild.TitleBg, "LEFT", 5, 0)
						SLH_ARDetailScrollFrameChild.title:SetText("Auto Repair Options")	
						SLH_ARDetailScrollFrameChild.title:SetTextColor(_G_SLH["SLH_SF"]["SLH_TitleColors"].r, _G_SLH["SLH_SF"]["SLH_TitleColors"].g, _G_SLH["SLH_SF"]["SLH_TitleColors"].b, _G_SLH["SLH_SF"]["SLH_TitleColors"].a)					

					--MasterFrame.SLH_ARDetail Buttons
						-- Enable_SLH_AR Check Button:
							Enable_SLH_AR = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_AROptions, --self
								"TOPLEFT", --point
								SLH_ARDetailScrollFrameChild, --relativeFrame
								"Enable_SLH_AR", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AR_Profile, --SVPath1
								"AR", --SVPath2
								"Enable", --SVPath3
								"Enable Auto Repair", --text
								"Enables Auto Repairing on Vendor Dilaog Open\n\nHolding Alt key disables Auto Repair on the fly" --tooltip
								)
								Enable_SLH_AR:HookScript("OnClick", function(self, arg1)			
									if Enable_SLH_AR:GetChecked() 
										then 
											_G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] = "Y"
											SLH_AR_SetVars(self, event, name)
											SLH_AR_Events(self, event, name)
										else 
											_G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] = "N"
											SLH_AREventFrame:UnregisterAllEvents()																		
									end
								end)
								
						-- Enable_SLH_AR Check Button:
							SLH_AR_PlayerFund = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_AROptions, --self
								"TOPLEFT", --point
								Enable_SLH_AR, --relativeFrame
								"SLH_AR_PlayerFund" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								AR_Profile, --SVPath1
								"AR", --SVPath2
								"PlayerFund", --SVPath3
								"Repair using Player Funds", --text
								"Repair using Player Funds?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AR Check Button:
							SLH_AR_GuildFund = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_AROptions, --self
								"TOPLEFT", --point
								SLH_AR_PlayerFund, --relativeFrame
								"SLH_AR_GuildFund" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AR_Profile, --SVPath1
								"AR", --SVPath2
								"GuildFund", --SVPath3
								"Repair using Guild Funds", --text
								"Repair using Guild Funds?\n\nYes or No" --tooltip
								)
						
			end

				
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AR_Load"] == "Y" then
				SLH_AR_SetVars(self, event, name, ...)
				SLH_AR_Events(self, event, name, ...)
			end
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AR_Hide"] == "N" then
				SLH_AR_Frames(self, event, name, ...)
			end
		
	end	)	